#include "avidll.h"
#include <windows.h>

BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

DLLIMPORT int GetImageSize(unsigned int* xsize,unsigned int* ysize,const char* filename) {
	HANDLE hFile;
	unsigned char typebuf[4];
	unsigned char sizebuf[4];
	unsigned char formbuf[4];
	unsigned char typebuf2[4];
	unsigned char sizebuf2[4];
	unsigned char imgsizebuf[8];
	unsigned int size;
	unsigned int size2;
	unsigned int readsizesum;
	int found;
	DWORD readsize;
	hFile=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE)return 1;
	if(!ReadFile(hFile,typebuf,4,&readsize,NULL) || readsize!=4) {
		CloseHandle(hFile);
		return 2;
	}
	if(typebuf[0]!=0x52 || typebuf[1]!=0x49 ||
			typebuf[2]!=0x46 || typebuf[3]!=0x46) {
		CloseHandle(hFile);
		return 4;
	}
	if(SetFilePointer(hFile,4,NULL,FILE_CURRENT)==0xFFFFFFFF) {
		CloseHandle(hFile);
		return 3;
	}
	if(!ReadFile(hFile,formbuf,4,&readsize,NULL) || readsize!=4) {
		CloseHandle(hFile);
		return 2;
	}
	if(formbuf[0]!=0x41 || formbuf[1]!=0x56 ||
			formbuf[2]!=0x49 || formbuf[3]!=0x20) {
		CloseHandle(hFile);
		return 4;
	}
	found=0;
	while(!found) {
		/*`N^Cv̓ǂݍ*/
		if(!ReadFile(hFile,typebuf,4,&readsize,NULL) || readsize!=4) {
			CloseHandle(hFile);
			return 2;
		}
		/*`NTCY̓ǂݍ*/
		if(!ReadFile(hFile,sizebuf,4,&readsize,NULL) || readsize!=4) {
			CloseHandle(hFile);
			return 2;
		}
		/*`NTCY̕ϊ*/
		size=(sizebuf[0]    )|
		     (sizebuf[1]<<8 )|
			 (sizebuf[2]<<16)|
			 (sizebuf[3]<<24);
		/*`N^Cv*/
		if(typebuf[0]==0x4C && typebuf[1]==0x49 &&
				typebuf[2]==0x53 && typebuf[3]==0x54) {
			/*LIST`NȂ*/
			if(!ReadFile(hFile,formbuf,4,&readsize,NULL) || readsize!=4) {
				CloseHandle(hFile);
				return 2;
			}
			if(formbuf[0]==0x68 && formbuf[1]==0x64 &&
					formbuf[2]==0x72 && formbuf[3]==0x6C) {
				/*hdrlȂ*/
				readsizesum=4;
				while(1) {
					if(!ReadFile(hFile,typebuf2,4,&readsize,NULL) || readsize!=4) {
						CloseHandle(hFile);
						return 2;
					}
					/*`NTCY̓ǂݍ*/
					if(!ReadFile(hFile,sizebuf2,4,&readsize,NULL) || readsize!=4) {
						CloseHandle(hFile);
						return 2;
					}
					/*`NTCY̕ϊ*/
					size2=(sizebuf2[0]    )|
					      (sizebuf2[1]<<8 )|
						  (sizebuf2[2]<<16)|
						  (sizebuf2[3]<<24);
					readsizesum+=8+size2;
					if(readsizesum>size) {
						CloseHandle(hFile);
						return 5;
					}
					if(typebuf2[0]==0x61 && typebuf2[1]==0x76 &&
							typebuf2[2]==0x69 && typebuf2[3]==0x68) {
						/*avih`NȂ*/
						if(size2<40) {
							CloseHandle(hFile);
							return 6;
						}
						if(SetFilePointer(hFile,32,NULL,FILE_CURRENT)==0xFFFFFFFF) {
							CloseHandle(hFile);
							return 3;
						}
						if(!ReadFile(hFile,imgsizebuf,8,&readsize,NULL) || readsize!=8) {
							CloseHandle(hFile);
							return 2;
						}
						*xsize=(imgsizebuf[0]    )|
						       (imgsizebuf[1]<<8 )|
						       (imgsizebuf[2]<<16)|
						       (imgsizebuf[3]<<24);
						*ysize=(imgsizebuf[4]    )|
						       (imgsizebuf[5]<<8 )|
						       (imgsizebuf[6]<<16)|
						       (imgsizebuf[7]<<24);
						found=1;
						break;
					}
				}
			} else {
				if(SetFilePointer(hFile,size-4,NULL,FILE_CURRENT)==0xFFFFFFFF) {
					CloseHandle(hFile);
					return 3;
				}
			}
		} else {
			/*̑Ȃǂݔ΂*/
			if(SetFilePointer(hFile,size,NULL,FILE_CURRENT)==0xFFFFFFFF) {
				CloseHandle(hFile);
				return 3;
			}
		}
	}
	CloseHandle(hFile);
    return 0;
}

DLLIMPORT const char* GetErrorMessage(int errorcode) {
	static const char* errormessage[7]={
		"t@CJ܂B",
		"t@Cǂݍ߂܂B",
		"t@C̃V[NɎs܂B",
		"AVIt@Cł͂܂B",
		"LIST`N(hdrl)Z܂B",
		"avih`NZ܂B",
		"sȃG[łB"
	};
	if(errorcode<=0 || errorcode>6) {
		return errormessage[6];
	}
	return errormessage[errorcode-1];
}
