#include "gifdll.h"
#include <windows.h>

BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

DLLIMPORT int GetImageSize(unsigned int* xsize,unsigned int* ysize,const char* filename) {
	HANDLE hFile;
	unsigned char buffer[10];
	DWORD readsize;
	hFile=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE)return 1;
	if(!ReadFile(hFile,buffer,10,&readsize,NULL) || readsize!=10) {
		CloseHandle(hFile);
		return 2;
	}
	CloseHandle(hFile);
	if(buffer[0]!=0x47 || buffer[1]!=0x49 || buffer[2]!=0x46)return 3;
	*xsize=buffer[6] | (buffer[7]<<8);
	*ysize=buffer[8] | (buffer[9]<<8);
    return 0;
}

DLLIMPORT const char* GetErrorMessage(int errorcode) {
	static const char* errormessage[4]={
		"t@CJ܂B",
		"t@Cǂݍ߂܂B",
		"GIFt@Cł͂܂B",
		"sȃG[łB"
	};
	if(errorcode<=0 || errorcode>3) {
		return errormessage[3];
	}
	return errormessage[errorcode-1];
}
