#include "jpgdll.h"
#include <windows.h>

BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

DLLIMPORT int GetImageSize(unsigned int* xsize,unsigned int* ysize,const char* filename) {
	HANDLE hFile;
	unsigned char typebuf[2];
	unsigned char DataPrecision;
	unsigned char sizebuf[2];
	unsigned char imgsizebuf[4];
	unsigned int size;
	DWORD readsize;
	hFile=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE)return 1;
	if(!ReadFile(hFile,typebuf,2,&readsize,NULL) || readsize!=2) {
		CloseHandle(hFile);
		return 2;
	}
	if(typebuf[0]!=0xFF || typebuf[1]!=0xD8) {
		CloseHandle(hFile);
		return 4;
	}
	while(1) {
		/*`N^Cv̓ǂݍ*/
		if(!ReadFile(hFile,typebuf,2,&readsize,NULL) || readsize!=2) {
			CloseHandle(hFile);
			return 2;
		}
		/*SOSȂG[I*/
		if(typebuf[0]==0xFF && typebuf[1]==0xDA) {
			CloseHandle(hFile);
			return 5;
		}
		/*`NTCY̓ǂݍ*/
		if(!ReadFile(hFile,sizebuf,2,&readsize,NULL) || readsize!=2) {
			CloseHandle(hFile);
			return 2;
		}
		/*`NTCY̕ϊ*/
		size=(sizebuf[0]<<8) | sizebuf[1];
		/*`N^Cv*/
		if(typebuf[0]==0xFF && (typebuf[1] & 0xF0)==0xC0 &&
				typebuf[1]!=0xC4 && typebuf[1]!=0xC8 && typebuf[1]!=0xCC) {
			/*SOF`NȂ*/
			if(!ReadFile(hFile,&DataPrecision,1,&readsize,NULL) || readsize!=1) {
				CloseHandle(hFile);
				return 2;
			}
			if(DataPrecision==0x08) {
				if(!ReadFile(hFile,imgsizebuf,4,&readsize,NULL) || readsize!=4) {
					CloseHandle(hFile);
					return 2;
				}
				*ysize=(imgsizebuf[0]<<8) | imgsizebuf[1];
				*xsize=(imgsizebuf[2]<<8) | imgsizebuf[3];
				break;
			} else {
				if(SetFilePointer(hFile,size-3,NULL,FILE_CURRENT)==0xFFFFFFFF) {
					CloseHandle(hFile);
					return 3;
				}
			}
		} else {
			/*̑Ȃǂݔ΂*/
			if(SetFilePointer(hFile,size-2,NULL,FILE_CURRENT)==0xFFFFFFFF) {
				CloseHandle(hFile);
				return 3;
			}
		}
	}
	CloseHandle(hFile);
    return 0;
}

DLLIMPORT const char* GetErrorMessage(int errorcode) {
	static const char* errormessage[6]={
		"t@CJ܂B",
		"t@Cǂݍ߂܂B",
		"t@C̃V[NɎs܂B",
		"JPGt@Cł͂܂B",
		"\kf[^ɓB܂B",
		"sȃG[łB"
	};
	if(errorcode<=0 || errorcode>5) {
		return errormessage[5];
	}
	return errormessage[errorcode-1];
}
