#include "psddll.h"
#include <windows.h>

BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

DLLIMPORT int GetImageSize(unsigned int* xsize,unsigned int* ysize,const char* filename) {
	HANDLE hFile;
	unsigned char buffer[0x16];
	DWORD readsize;
	hFile=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE)return 1;
	if(!ReadFile(hFile,buffer,0x16,&readsize,NULL) || readsize!=0x16) {
		CloseHandle(hFile);
		return 2;
	}
	CloseHandle(hFile);
	if(buffer[0x00]!=0x38 || buffer[0x01]!=0x42 ||
		buffer[0x02]!=0x50 || buffer[0x03]!=0x53 ||
		buffer[0x04]!=0x00 || buffer[0x05]!=0x01)return 3;
	*ysize=(buffer[0x0E]<<24)|
           (buffer[0x0F]<<16)|
           (buffer[0x10]<<8 )|
           (buffer[0x11]    );
	*xsize=(buffer[0x12]<<24)|
           (buffer[0x13]<<16)|
           (buffer[0x14]<<8 )|
           (buffer[0x15]    );
    return 0;
}

DLLIMPORT const char* GetErrorMessage(int errorcode) {
	static const char* errormessage[4]={
		"t@CJ܂B",
		"t@Cǂݍ߂܂B",
		"PSDt@Cł͂܂B",
		"sȃG[łB"
	};
	if(errorcode<=0 || errorcode>3) {
		return errormessage[3];
	}
	return errormessage[errorcode-1];
}
