#include "pngdll.h"
#include <windows.h>

BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

DLLIMPORT int GetImageSize(unsigned int* xsize,unsigned int* ysize,const char* filename) {
	HANDLE hFile;
	unsigned char signature[8];
	unsigned char lengthbuf[4];
	unsigned char typebuf[4];
	unsigned char imgsizebuf[8];
	unsigned int size;
	DWORD readsize;
	hFile=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE)return 1;
	if(!ReadFile(hFile,signature,8,&readsize,NULL) || readsize!=8) {
		CloseHandle(hFile);
		return 2;
	}
	if(signature[0]!=0x89 || signature[1]!=0x50 ||
			signature[2]!=0x4E || signature[3]!=0x47 ||
			signature[4]!=0x0D || signature[5]!=0x0A ||
			signature[6]!=0x1A || signature[7]!=0x0A) {
		CloseHandle(hFile);
		return 4;
	}
	while(1) {
		/*`NTCY̓ǂݍ*/
		if(!ReadFile(hFile,lengthbuf,4,&readsize,NULL) || readsize!=4) {
			CloseHandle(hFile);
			return 2;
		}
		/*`N^Cv̓ǂݍ*/
		if(!ReadFile(hFile,typebuf,4,&readsize,NULL) || readsize!=4) {
			CloseHandle(hFile);
			return 2;
		}
		/*IENDȂG[I*/
		if(typebuf[0]==0x49 && typebuf[1]==0x45 &&
				typebuf[2]==0x4E && typebuf[3]==0x44) {
			CloseHandle(hFile);
			return 5;
		}
		/*`NTCY̕ϊ*/
		size=(lengthbuf[0]<<24)|
		     (lengthbuf[1]<<16)|
			 (lengthbuf[2]<<8 )|
			 (lengthbuf[3]    );
		/*`N^Cv*/
		if(typebuf[0]==0x49 && typebuf[1]==0x48 &&
				typebuf[2]==0x44 && typebuf[3]==0x52) {
			/*IHDR`NȂ*/
			if(size<8) {
				CloseHandle(hFile);
				return 6;
			}
			if(!ReadFile(hFile,imgsizebuf,8,&readsize,NULL) || readsize!=8) {
				CloseHandle(hFile);
				return 2;
			}
			*xsize=(imgsizebuf[0]<<24)|
			       (imgsizebuf[1]<<16)|
			       (imgsizebuf[2]<<8 )|
			       (imgsizebuf[3]    );
			*ysize=(imgsizebuf[4]<<24)|
			       (imgsizebuf[5]<<16)|
			       (imgsizebuf[6]<<8 )|
			       (imgsizebuf[7]    );
			break;
		} else {
			/*̑Ȃǂݔ΂*/
			if(SetFilePointer(hFile,size+4,NULL,FILE_CURRENT)==0xFFFFFFFF) {
				CloseHandle(hFile);
				return 3;
			}
		}
	}
	CloseHandle(hFile);
    return 0;
}

DLLIMPORT const char* GetErrorMessage(int errorcode) {
	static const char* errormessage[7]={
		"t@CJ܂B",
		"t@Cǂݍ߂܂B",
		"t@C̃V[NɎs܂B",
		"PNGt@Cł͂܂B",
		"\I[ɓB܂B",
		"IHDR`NZ܂B",
		"sȃG[łB"
	};
	if(errorcode<=0 || errorcode>6) {
		return errormessage[6];
	}
	return errormessage[errorcode-1];
}
