#include <stdio.h>
#include <stdlib.h>
#include "gazousize.h"

void calc_size(HWND hWnd) {
	char strbuf[100];
	char strbuf2[100];
	long long source_xsize;
	long long source_ysize;
	long long target_xsize;
	long long target_ysize;
	long long result_xsize;
	long long result_ysize;
	int type;
	int stretch;
	int error;
	int overflow;
	int ofcheck;
	/*擾*/
	error=0;
	overflow=0;
	GetWindowText(GetDlgItem(hWnd,IDC_EDIT_SOURCE_X),strbuf,sizeof(strbuf));
	if(lstrlen(strbuf)==0)error=1; else {
		source_xsize=atoll(strbuf);
		sprintf(strbuf2,"%lld",source_xsize);
		if(strcmp(strbuf,strbuf2)!=0)overflow=1;
	}
	GetWindowText(GetDlgItem(hWnd,IDC_EDIT_SOURCE_Y),strbuf,sizeof(strbuf));
	if(lstrlen(strbuf)==0)error=1; else {
		source_ysize=atoll(strbuf);
		sprintf(strbuf2,"%lld",source_ysize);
		if(strcmp(strbuf,strbuf2)!=0)overflow=1;
	}
	GetWindowText(GetDlgItem(hWnd,IDC_EDIT_TARGET_X),strbuf,sizeof(strbuf));
	if(lstrlen(strbuf)==0)error=1; else {
		target_xsize=atoll(strbuf);
		sprintf(strbuf2,"%lld",target_xsize);
		if(strcmp(strbuf,strbuf2)!=0)overflow=1;
	}
	GetWindowText(GetDlgItem(hWnd,IDC_EDIT_TARGET_Y),strbuf,sizeof(strbuf));
	if(lstrlen(strbuf)==0)error=1; else {
		target_ysize=atoll(strbuf);
		sprintf(strbuf2,"%lld",target_ysize);
		if(strcmp(strbuf,strbuf2)!=0)overflow=1;
	}
	type=SendMessage(GetDlgItem(hWnd,IDC_COMBO_TYPE),CB_GETCURSEL,0,0);
	stretch=SendMessage(GetDlgItem(hWnd,IDC_COMBO_STRETCH),CB_GETCURSEL,0,0);
	if(error) {
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_X),"͂");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_Y),"");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_TAG),"");
		return;
	}
	if(overflow) {
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_X),"G[");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_Y),"I[o[t[");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_TAG),"");
		return;
	}
	if(source_xsize<=0 || source_ysize<=0 || target_xsize<=0 || target_ysize<=0) {
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_X),"G[");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_Y),"摜̃TCY0͕s");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_TAG),"");
		return;
	}
	/*vZ*/
	/*揜͎ľܓgp*/
	switch(type) {
		case 0:
			/*gɎ߂*/
			if(!stretch && source_xsize<=target_xsize && source_ysize<=target_ysize) {
				result_xsize=source_xsize;
				result_ysize=source_ysize;
			} else {
				/*Ƃ肠cɍ킹*/
				ofcheck=source_xsize*10*target_ysize;
				if(ofcheck<source_xsize || ofcheck<target_ysize) {
					ofcheck=source_xsize*target_ysize;
					if(ofcheck<source_xsize || ofcheck<target_ysize)overflow=1;
					result_xsize=source_xsize*target_ysize/source_ysize;
				} else {
					result_xsize=source_xsize*10*target_ysize/source_ysize;
					if(result_xsize%10>=5) {
						if(result_xsize+10<result_xsize)overflow=1;
						result_xsize+=10;
					}
					result_xsize/=10;
				}
				result_ysize=target_ysize;
				/*܂ĂȂ牡ɍ킹*/
				if(result_xsize>target_xsize) {
					result_xsize=target_xsize;
					ofcheck=source_ysize*10*target_xsize;
					if(ofcheck<source_ysize || ofcheck<target_xsize) {
						ofcheck=source_ysize*target_xsize;
						if(ofcheck<source_ysize || ofcheck<target_xsize)overflow=1;
						result_ysize=source_ysize*target_xsize/source_xsize;
					} else {
						result_ysize=source_ysize*10*target_xsize/source_xsize;
						if(result_ysize%10>=5) {
							if(result_ysize+10<result_ysize)overflow=1;
							result_ysize+=10;
						}
						result_ysize/=10;
					}
					if(result_ysize>target_ysize)result_ysize=target_ysize;
				}
			}
			break;
		case 1:
			/*g𖄂߂*/
			if(!stretch && (source_xsize<=target_xsize || source_ysize<=target_ysize)) {
				result_xsize=source_xsize;
				result_ysize=source_ysize;
			} else {
				/*Ƃ肠cɍ킹*/
				ofcheck=source_xsize*10*target_ysize;
				if(ofcheck<source_xsize || ofcheck<target_ysize) {
					ofcheck=source_xsize*target_ysize;
					if(ofcheck<source_xsize || ofcheck<target_ysize)overflow=1;
					result_xsize=source_xsize*target_ysize/source_ysize;
				} else {
					result_xsize=source_xsize*10*target_ysize/source_ysize;
					if(result_xsize%10>=5) {
						if(result_xsize+10<result_xsize)overflow=1;
						result_xsize+=10;
					}
					result_xsize/=10;
				}
				result_ysize=target_ysize;
				/*Ȃ牡ɍ킹*/
				if(result_xsize<target_xsize) {
					result_xsize=target_xsize;
					ofcheck=source_ysize*10*target_xsize;
					if(ofcheck<source_ysize || ofcheck<target_xsize) {
						ofcheck=source_ysize*target_xsize;
						if(ofcheck<source_ysize || ofcheck<target_xsize)overflow=1;
						result_ysize=source_ysize*target_xsize/source_xsize;
					} else {
						result_ysize=source_ysize*10*target_xsize/source_xsize;
						if(result_ysize%10>=5) {
							if(result_ysize+10<result_ysize)overflow=1;
							result_ysize+=10;
						}
						result_ysize/=10;
					}
					if(result_ysize<target_ysize)result_ysize=target_ysize;
				}
			}
			break;
		case 2:
			/*c䖳*/
			if(stretch) {
				result_xsize=target_xsize;
				result_ysize=target_ysize;
			} else {
				result_xsize=(source_xsize<target_xsize?source_xsize:target_xsize);
				result_ysize=(source_ysize<target_ysize?source_ysize:target_ysize);
			}
			break;
		default:
			error=1;
	}
	/*G[`FbN*/
	if(error) {
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_X),"G[");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_Y),"vZ^Cvs");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_TAG),"");
		return;
	}
	if(overflow) {
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_X),"G[");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_Y),"I[o[t[");
		SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_TAG),"");
		return;
	}
	/*ʂ\*/
	sprintf(strbuf,"%lld",result_xsize);
	SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_X),strbuf);
	sprintf(strbuf,"%lld",result_ysize);
	SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_Y),strbuf);
	sprintf(strbuf,"width=\"%lld\" height=\"%lld\"",result_xsize,result_ysize);
	SetWindowText(GetDlgItem(hWnd,IDC_EDIT_RESULT_TAG),strbuf);
	/*KvȂRs[*/
	if(SendMessage(GetDlgItem(hWnd,IDC_CHECK_AUTOCOPY),BM_GETCHECK,0,0)) {
		copy_html(hWnd);
	}
}
