#include "gazousize.h"

static char ininame[1024]={0};
static int usereg=0;

void config_load(HWND hWnd) {
	char xsize[100]="200";
	char ysize[100]="200";
	int type=0;
	int stretch=0;
	int autocopy=0;
	if(ininame[0]==0)wsprintf(ininame,"%sgazousize.ini",getExeDir());
	usereg=GetPrivateProfileInt("config","useregistry",0,ininame);
	if(usereg) {
		/*WXgݒǂݍ*/
		HKEY hRegKey;
		DWORD bufsize;
		if(RegOpenKeyEx(HKEY_CURRENT_USER,
				"Software\\mikeCAT\\gazousize",
				0,KEY_QUERY_VALUE,&hRegKey)==ERROR_SUCCESS) {
			bufsize=sizeof(xsize);
			RegQueryValueEx(hRegKey,"xsize",0,NULL,(LPBYTE)xsize,&bufsize);
			bufsize=sizeof(ysize);
			RegQueryValueEx(hRegKey,"ysize",0,NULL,(LPBYTE)ysize,&bufsize);
			bufsize=sizeof(type);
			RegQueryValueEx(hRegKey,"type",0,NULL,(LPBYTE)&type,&bufsize);
			bufsize=sizeof(stretch);
			RegQueryValueEx(hRegKey,"stretch",0,NULL,(LPBYTE)&stretch,&bufsize);
			bufsize=sizeof(autocopy);
			RegQueryValueEx(hRegKey,"autocopy",0,NULL,(LPBYTE)&autocopy,&bufsize);
			RegCloseKey(hRegKey);
		}
	} else {
		/*init@Cݒǂݍ*/
		GetPrivateProfileString("size","xsize","200",xsize,sizeof(xsize),ininame);
		GetPrivateProfileString("size","ysize","200",ysize,sizeof(ysize),ininame);
		type=GetPrivateProfileInt("action","type",0,ininame);
		stretch=GetPrivateProfileInt("action","stretch",0,ininame);
		autocopy=GetPrivateProfileInt("copy","autocopy",0,ininame);
	}
	/*ݒEBhEɔf*/
	SetWindowText(GetDlgItem(hWnd,IDC_EDIT_TARGET_X),xsize);
	SetWindowText(GetDlgItem(hWnd,IDC_EDIT_TARGET_Y),ysize);
	SendMessage(GetDlgItem(hWnd,IDC_COMBO_TYPE),CB_SETCURSEL,type,0);
	SendMessage(GetDlgItem(hWnd,IDC_COMBO_STRETCH),CB_SETCURSEL,stretch,0);
	SendMessage(GetDlgItem(hWnd,IDC_CHECK_AUTOCOPY),BM_SETCHECK,autocopy,0);
}

void config_save(HWND hWnd) {
	char xsize[100]="200";
	char ysize[100]="200";
	int type=0;
	int stretch=0;
	int autocopy=0;
	char strbuffer[100];
	/*ݒ擾*/
	GetWindowText(GetDlgItem(hWnd,IDC_EDIT_TARGET_X),xsize,sizeof(xsize));
	GetWindowText(GetDlgItem(hWnd,IDC_EDIT_TARGET_Y),ysize,sizeof(ysize));
	type=SendMessage(GetDlgItem(hWnd,IDC_COMBO_TYPE),CB_GETCURSEL,0,0);
	stretch=SendMessage(GetDlgItem(hWnd,IDC_COMBO_STRETCH),CB_GETCURSEL,0,0);
	autocopy=SendMessage(GetDlgItem(hWnd,IDC_CHECK_AUTOCOPY),BM_GETCHECK,0,0);
	/*ݒ*/
	if(ininame[0]==0)wsprintf(ininame,"%sgazousize.ini",getExeDir());
	if(usereg) {
		/*WXgɐݒ*/
		HKEY hRegKey;
		if(RegCreateKeyEx(HKEY_CURRENT_USER,
				"Software\\mikeCAT\\gazousize",
				0,NULL,0,KEY_SET_VALUE,NULL,&hRegKey,NULL)==ERROR_SUCCESS) {
			RegSetValueEx(hRegKey,"xsize",0,REG_SZ,(LPBYTE)xsize,lstrlen(xsize));
			RegSetValueEx(hRegKey,"ysize",0,REG_SZ,(LPBYTE)ysize,lstrlen(ysize));
			RegSetValueEx(hRegKey,"type",0,REG_DWORD,(LPBYTE)&type,sizeof(type));
			RegSetValueEx(hRegKey,"stretch",0,REG_DWORD,(LPBYTE)&stretch,sizeof(stretch));
			RegSetValueEx(hRegKey,"autocopy",0,REG_DWORD,(LPBYTE)&autocopy,sizeof(autocopy));
			RegCloseKey(hRegKey);
		}
	} else {
		/*init@Cɐݒ*/
		WritePrivateProfileString("size","xsize",xsize,ininame);
		WritePrivateProfileString("size","ysize",ysize,ininame);
		wsprintf(strbuffer,"%d",type);
		WritePrivateProfileString("action","type",strbuffer,ininame);
		wsprintf(strbuffer,"%d",stretch);
		WritePrivateProfileString("action","stretch",strbuffer,ininame);
		wsprintf(strbuffer,"%d",autocopy);
		WritePrivateProfileString("copy","autocopy",strbuffer,ininame);
	}
}
